;================================================================================
;
;	Podprogramy pro zobrazovani data a casu
;
;	cas_h	_H
;	cas_hh	HH
;	cas_mm	MM
;	cas_ss	SS
;	
;	dat_d	_D
;	dat_dd	DD
;	dat_m	M
;	dat_mm	MM
;	dat_rr	RR
;	dat_4r	20RR
;
;================================================================================
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi hodiny "_H" s mezerou misto nuly na zacatku
;-------------------------------------------------------------------------------
cas_h
	bcf	HODINY,6	;vymaz priznak 12/24
	movf	HODINY,W	;nacti hodiny
	movwf	BCD
	call	roBCD
;       ------------------------
	movf	BCDD,W		;jsou-li desitky hodin 0
	btfsc	STATUS,Z
	call	znak_		;.. pak zobraz mezeru
	movf	BCDD,W
	btfss	STATUS,Z
	call	disphex		;.. jinak zobraz desitky hodin
;       ------------------------
	movf	BCDJ,W		;zobraz jednotky hodin
	call	disphex
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi hodiny "HH" s nulou na zacatku
;-------------------------------------------------------------------------------
cas_hh
	bcf	HODINY,6	;vymaz priznak 12/24
	movf	HODINY,W	;nacti hodiny
	call	disphe2		;"HH"
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi minuty "MM"
;-------------------------------------------------------------------------------
cas_mm
	movf	MINUTY,W	;nacti minuty
	call	disphe2		;"MM"
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi sekundy "SS"
;-------------------------------------------------------------------------------
cas_ss
	bcf	SEKUNDY,7	;vymaz priznak CH
	movf	SEKUNDY,W		;nacti sekundy
	call	disphe2		;"SS"
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi den "_D" s mezerou misto nuly na zacatku
;-------------------------------------------------------------------------------
dat_d
	movf	DEN,W		;nacti den do BCD
	movwf	BCD
	call	roBCD		;rozdel desitky a jednotky
;       ------------------------
	movf	BCDD,W		;jsou-li destitky 0
	btfsc	STATUS,Z
	call	znak_		;.. zobraz mezeru
;       ------------------------
	movf	BCDD,W
	btfss	STATUS,Z
	call	disphex		;.. jinak zobraz desitky
;       ------------------------
	movf	BCDJ,W		;zobraz jednotky
	call	disphex
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi den "DD" s nulou na zacatku
;-------------------------------------------------------------------------------
dat_dd
	movf	DEN,W		;nacti den
	call	disphe2		;"DD"
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi mesic "M" bez nuly na zacatku
;-------------------------------------------------------------------------------
dat_m
	movf	MESIC,W		;nacti mesic do BCD
	movwf	BCD
	call	roBCD		;rozdel desitky a jednotky
;       ------------------------
	movf	BCDD,W		;jsou-li destitky 0
	btfsc	STATUS,Z
	nop			;.. nic nezobrazuj
;       ------------------------
	movf	BCDD,W
	btfss	STATUS,Z
	call	disphex		;.. jinak zobraz desitky
;       ------------------------
	movf	BCDJ,W		;zobraz jednotky
	call	disphex
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi mesic "MM" s nulou na zacatku
;-------------------------------------------------------------------------------
dat_mm
	movf	MESIC,W		;nacti mesic
	call	disphe2		;"MM"
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi rok "RR" bez "20" na zacatku
;-------------------------------------------------------------------------------
dat_rr
	movf	ROK,W		;nacti rok
	call	disphe2		;"RR"
;       ------------------------
	return
;-------------------------------------------------------------------------------
; Na aktualni pozici na displeji zobrazi rok "20RR" s "20" na zacatku
;-------------------------------------------------------------------------------
dat_4r
	call	znak_2
	call	znak_0
	call	dat_rr
;       ------------------------
	return