;================================================================================
;
;	Vyhodnoceni nastavenych limitu vcetne nastaveni pozadavku
;	na dlouhe pipnuti pri prekroceni limitu
;
;================================================================================
limity	bcf	BEEPD		;vymaz pozadavek dlouheho pipnuti
;-------------------------------
limT2	movf	T2DE,W		;sluc desitky (T2DE) a jednotky (T2JE) do BCD
	movwf	BCDD
	movf	T2JE,W
	movwf	BCDJ
	call	slBCD
;	------------------------
	movlw	0x85		;osetreni chyby cidla 85,0
	movwf	DAT
	movf	BCD,W		;je teplota 85?
	subwf	DAT,W
	btfss	STATUS,Z
	goto	chT2ne
	movf	T2DT,F		;.. pokud ano, jeste kontrola desetin
	btfsc	STATUS,Z	;kdyz je 85,0..
	goto	limT3		;..vse preskoc a pokracuj na dalsim cidle
;	------------------------
chT2ne	movf	T2L2,W		;zkopiruj T2L2 do DAT
	movwf	DAT
	btfsc	T2S2		;pokud jiz je T nad lim2..
	decf	DAT,F		;sniz DAT o 1 (hystereze)
	movf	BCD,W		;je teplota nad limit 2?
	subwf	DAT,W
	btfss	STATUS,C
	goto	lim2T2		;..pak skoc
;	------------------------
	movf	T2L1,W		;zkopiruj T2L1 do DAT
	movwf	DAT
	btfsc	T2S1		;pokud jiz je T pod lim1..
	incf	DAT,F		;zvys DAT o 1 (hystereze)
	movf	DAT,W		;je teplota pod limit 1?
	subwf	BCD,W
	btfss	STATUS,C
	goto	lim1T2		;..pak skoc
;	------------------------
	btfsc	T2S2		;byla teplota nad limit 2?
	bsf	BEEPD		;..pak dlouze beep
	btfsc	T2S1		;byla teplota pod limit 1?
	bsf	BEEPD		;..pak dlouze beep
;
	bcf	T2S2		;vymaz priznak horniho limitu
	bcf	T2S1		;vymaz priznak spodniho limitu
;	------------------------
	goto	limT3
;-------------------------------
lim2T2	bsf	T2S2		;nastav priznak limitu
	bcf	T2S1
;	------------------------
	goto	limT3
;-------------------------------
lim1T2	btfss	T2S1		;jestli zmena stavu, dlouze beep
	bsf	BEEPD	
;	------------------------
	bsf	T2S1		;nastav priznak limitu
	bcf	T2S2
;	------------------------
	goto	limT3
;--------------------------------------------------------------------------------
limT3	movf	T3DE,W		;sluc desitky (T3DE) a jednotky (T3JE) do BCD
	movwf	BCDD
	movf	T3JE,W
	movwf	BCDJ
	call	slBCD
;	------------------------
	movlw	0x85		;osetreni chyby cidla 85,0
	movwf	DAT
	movf	BCD,W		;je teplota 85?
	subwf	DAT,W
	btfss	STATUS,Z
	goto	chT3ne
	movf	T3DT,F		;.. pokud ano, jeste kontrola desetin
	btfsc	STATUS,Z	;kdyz je 85,0..
	goto	limT4		;..vse preskoc a pokracuj na dalsim cidle
;	------------------------
chT3ne	movf	T4L2,W		;zkopiruj T4L2 do DAT
	movwf	DAT
	btfsc	T3S2		;pokud jiz je T nad lim2..
	decf	DAT,F		;sniz DAT o 1 (hystereze)
	movf	BCD,W		;je teplota nad limit 2?
	subwf	DAT,W
	btfss	STATUS,C
	goto	lim2T3		;..pak skoc
;	------------------------
	movf	T4L1,W		;zkopiruj T4L1 do DAT
	movwf	DAT
	btfsc	T3S1		;pokud jiz je T pod lim1..
	incf	DAT,F		;zvys DAT o 1 (hystereze)
	movf	DAT,W		;je teplota pod limit 1?
	subwf	BCD,W
	btfss	STATUS,C
	goto	lim1T3		;..pak skoc
;	------------------------
	btfsc	T3S2		;byla teplota nad limit 2?
	bsf	BEEPD		;..pak dlouze beep
;
	bcf	T3S2		;vymaz priznak horniho limitu
	bcf	T3S1		;vymaz priznak spodniho limitu
;	------------------------
	goto	limT4
;-------------------------------
lim2T3	bsf	T3S2		;nastav priznak limitu
	bcf	T3S1
;	------------------------
	goto	limT4
;-------------------------------
lim1T3	bsf	T3S1		;nastav priznak limitu
	bcf	T3S2
;	------------------------
	goto	limT4
;--------------------------------------------------------------------------------
limT4	movf	T4DE,W		;sluc desitky (T4DE) a jednotky (T4JE) do BCD
	movwf	BCDD
	movf	T4JE,W
	movwf	BCDJ
	call	slBCD
;	------------------------
	movlw	0x85		;osetreni chyby cidla 85,0
	movwf	DAT
	movf	BCD,W		;je teplota 85?
	subwf	DAT,W
	btfss	STATUS,Z
	goto	chT4ne
	movf	T4DT,F		;.. pokud ano, jeste kontrola desetin
	btfsc	STATUS,Z	;kdyz je 85,0..
	goto	limT4k		;..vse preskoc
;	------------------------
chT4ne	movf	T4L2,W		;zkopiruj T4L2 do DAT
	movwf	DAT
	btfsc	T4S2		;pokud jiz je T nad lim2..
	decf	DAT,F		;sniz DAT o 1 (hystereze)
	movf	BCD,W		;je teplota nad limit 2?
	subwf	DAT,W
	btfss	STATUS,C
	goto	lim2T4		;..pak skoc
;	------------------------
	movf	T4L1,W		;zkopiruj T4L1 do DAT
	movwf	DAT
	btfsc	T4S1		;pokud jiz je T pod lim1..
	incf	DAT,F		;zvys DAT o 1 (hystereze)
	movf	DAT,W		;je teplota pod limit 1?
	subwf	BCD,W
	btfss	STATUS,C
	goto	lim1T4		;..pak skoc
;	------------------------
	btfsc	T4S2		;byla teplota nad limit 2?
	bsf	BEEPD		;..pak dlouze beep
	btfsc	T4S1		;byla teplota pod limit 1?
	bsf	BEEPD		;..pak dlouze beep
;;	------------------------
	bcf	T4S2		;vymaz priznak horniho limitu
	bcf	T4S1		;vymaz priznak spodniho limitu
;	------------------------
	goto	limT4k
;-------------------------------
lim2T4	bsf	T4S2		;nastav priznak limitu
	bcf	T4S1
;	------------------------
	goto	limT4k
;-------------------------------
lim1T4	btfss	T4S1		;jestli zmena stavu, dlouze pipni
	bsf	BEEPD	
;	------------------------
	bsf	T4S1		;nastav priznak limitu
	bcf	T4S2
;-------------------------------
limT4k
;--------------------------------------------------------------------------------
;	Kontrola stavu akumulatoru
;--------------------------------------------------------------------------------
limAku	movf	ADE,W		;vynasob desitky 100x
	movwf	DAT
	call	nasob10
	call	nasob10
	movf	DAT,W
	movwf	TMP2
;	------------------------
	movf	AJE,W		;vynasob jednotky 10x
	movwf	DAT
	call	nasob10
	movf	DAT,W
	movwf	TMP3
;	------------------------
	movf	ADT,W		;secti 100 . ADE + 10 . AJE + ADT
	addwf	TMP2,W
	addwf	TMP3,W
	movwf	DAT		;nyni je v dat cislo k porovnani
;-------------------------------
	movlw	0x90		;je napeti vyssi nez 14,4V (144 = 90h)?
	movwf	TMP1
	movf	DAT,W
	subwf	TMP1,W
	btfss	STATUS,C
	goto	limA2		;..pak skoc
;	------------------------
	movlw	.123		;je napeti pod 12,3V (123)?
	subwf	DAT,W
	btfss	STATUS,C
	goto	limA1		;..pak skoc
;-------------------------------
	bcf	AS1		;vymaz priznaky limitu
	bcf	AS2
;	------------------------
	goto	limAkuk
;-------------------------------
limA1	bsf	AS1		;nastav limit nizkeho napeti
	bcf	AS2
;	------------------------
	goto	limAkuk
;-------------------------------
limA2	bcf	AS1		;nastav limit vysokeho napeti
	bsf	AS2
;	------------------------
	goto	limAkuk
;-------------------------------
;	DAT = 10 . DAT
;-------------------------------
nasob10	clrf	TMP1
;	------------------------
	rlncf	DAT,F
	movf	DAT,W
	addwf	TMP1,F
;	------------------------
	rlncf	DAT,F
	rlncf	DAT,F
	movf	DAT,W
	addwf	TMP1,F
;	------------------------
	movf	TMP1,W
	movwf	DAT
;	------------------------
	return
;-------------------------------
limAkuk
;--------------------------------------------------------------------------------
;	Vyhodnoceni alarmu
;--------------------------------------------------------------------------------
alarmy	clrf	ALARM		;vymaz alarmy
;	------------------------
	btfsc	T2S2		;pretopeni kotle
	goto	al_kot
	btfsc	T3S2		;prehrati bojleru
	goto	al_boj
	btfsc	T4S2		;prehrati bojleru
	goto	al_boj
;
	btfsc	Z1		;zaplava kuchyne
	goto	al_zap
	btfsc	Z2		;zaplava kotelna
	goto	al_zap
	btfsc	Z3		;zaplava koupelna
	goto	al_zap
;	------------------------
	return
;-------------------------------
al_kot	bsf	ALARM,0		;alarm kotel
;	------------------------
	return
;-------------------------------
al_boj	bsf	ALARM,0		;alarm bojler
;	------------------------
	return
;-------------------------------
al_zap	bsf	ALARM,0		;alarm zaplava
;	------------------------
	return