;================================================================================
;
;	Zobrazovani textovych informaci vcetne alarmu a zvuky alarmu
;
;================================================================================
hlaseni
	btfsc	T2S2		;alarm kotle
	call	alarm01
;
	btfsc	Z1		;alarm zaplava kuchyne
	call	alarm03
;
	btfsc	Z2		;alarm zaplava kotelna
	call	alarm04
;
	btfsc	Z3		;alarm zaplava koupelna
	call	alarm05
;
	btfsc	T3S2		;alarm bojleru (zvuk alarmu pouze jednou)
	goto	alarm02
	btfsc	T4S2
	goto	alarm02
;
chyby	btfsc	ERR01		;chyba periferie kotel
	call	chyba01
	btfsc	ERR02		;chyba periferie bojler
	call	chyba02
	btfsc	ERR03		;chyba periferie alarm
	call	chyba03
	btfsc	ERR04		;chyba periferie zaplava
	call	chyba04
;
stavy	btfsc	Z1
	goto	sta01
	btfsc	Z1A		;Z1a aktivni
	call	stav03
	btfsc	Z1B		;Z1b aktivni
	call	stav04
;
sta01	btfsc	Z2
	goto	sta02
	btfsc	Z2A		;Z2a aktivni
	call	stav05
	btfsc	Z2B		;Z2b aktivni
	call	stav06
;
sta02	btfsc	Z3
	goto	sta03
	btfsc	Z3A		;Z3a aktivni
	call	stav07
	btfsc	Z3B		;Z3baktivni
	call	stav08
;
sta03	btfsc	AS1		;nizke napeti akumulatoru
	call	stav09
	btfsc	AS2		;vysoke napeti akumulatoru
	call	stav10
;
	btfss	PGX		;alarm zakodovan
	call	stav01
	btfss	PGY		;vypadek site
	call	stav02
;	------------------------
	return
;-------------------------------
;	Staly text pri alarmu
;-------------------------------
alarmst	call	dispclr
;	------------------------
	movlw	0x03
	call	pozice
;	------------------------
	call	znak_vy
	call	znak_vy
	call	znak_vy
	call	znak_
	call	znak_A
	call	znak_L
	call	znak_A
	call	znak_R
	call	znak_M
	call	znak_
	call	znak_vy
	call	znak_vy
	call	znak_vy
;	------------------------
	movlw	0x40
	call	pozice
;	------------------------
	return
;-------------------------------
;	Alarm kotel
;-------------------------------
alarm01	call	alarmst
;	------------------------
	call	znak_
	call	znak_
	call	znak_p
	call	znak_rh
	call	znak_e
	call	znak_t
	call	znak_o
	call	znak_p
	call	znak_e
	call	znak_n
	call	znak_ic
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_t
	call	znak_l
	call	znak_e
	call	znak_
	call	znak_
	call	znak_
;	------------------------
	call	beep_a		;beep alarm
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Alarm bojler
;-------------------------------
alarm02	call	alarmst
;	------------------------
	call	znak_
	call	znak_
	call	znak_p
	call	znak_rh
	call	znak_e
	call	znak_h
	call	znak_r
	call	znak_ac
	call	znak_t
	call	znak_ic
	call	znak_
	call	znak_b
	call	znak_o
	call	znak_j
	call	znak_l
	call	znak_e
	call	znak_r
	call	znak_u
	call	znak_
	call	znak_
;	------------------------
	call	beep_a		;beep alarm
;	------------------------
	call	dispclr
;	------------------------
	goto	chyby
;-------------------------------
;	Alarm zaplava kuchyne
;-------------------------------
alarm03	call	alarmst
;	------------------------
	call	znak_
	call	znak_z
	call	znak_ac
	call	znak_p
	call	znak_l
	call	znak_a
	call	znak_v
	call	znak_a
	call	znak_
	call	znak_v
	call	znak_
	call	znak_k
	call	znak_u
	call	znak_c
	call	znak_h
	call	znak_y
	call	znak_n
	call	znak_i
	call	znak_
	call	znak_
;	------------------------
	call	beep_a		;beep alarm
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Alarm zaplava kotelna
;-------------------------------
alarm04	call	alarmst
;	------------------------
	call	znak_
	call	znak_z
	call	znak_ac
	call	znak_p
	call	znak_l
	call	znak_a
	call	znak_v
	call	znak_a
	call	znak_
	call	znak_v
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_t
	call	znak_e
	call	znak_l
	call	znak_n
	call	znak_eh
	call	znak_
	call	znak_
;	------------------------
	call	beep_a		;beep alarm
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Alarm zaplava koupelna
;-------------------------------
alarm05	call	alarmst
;	------------------------
	call	znak_
	call	znak_z
	call	znak_ac
	call	znak_p
	call	znak_l
	call	znak_a
	call	znak_v
	call	znak_a
	call	znak_
	call	znak_v
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_u
	call	znak_p
	call	znak_e
	call	znak_l
	call	znak_n
	call	znak_eh
	call	znak_
;	------------------------
	call	beep_a		;beep alarm
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Staly text pri chybovem hlaseni
;-------------------------------
chybast	call	dispclr
;	------------------------
	movlw	0x02
	call	pozice
;	------------------------
	call	znak_c
	call	znak_h
	call	znak_y
	call	znak_b
	call	znak_a
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_m
	call	znak_u
	call	znak_n
	call	znak_i
	call	znak_k
	call	znak_a
	call	znak_c
	call	znak_e
;	------------------------
	return
;-------------------------------
;	Chyba periferie kotel
;-------------------------------
chyba01	call	chybast
;	------------------------
	movlw	0x47
	call	pozice
;	------------------------
	call	znak_k
	call	znak_o
	call	znak_t
	call	znak_e
	call	znak_l
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Chyba periferie bojler
;-------------------------------
chyba02	call	chybast
;	------------------------
	movlw	0x47
	call	pozice
;	------------------------
	call	znak_b
	call	znak_o
	call	znak_j
	call	znak_l
	call	znak_e
	call	znak_r
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Chyba periferie alarm
;-------------------------------
chyba03	call	chybast
;	------------------------
	movlw	0x47
	call	pozice
;	------------------------
	call	znak_a
	call	znak_l
	call	znak_a
	call	znak_r
	call	znak_m
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Chyba periferie zaplava
;-------------------------------
chyba04	call	chybast
;	------------------------
	movlw	0x46
	call	pozice
;	------------------------
	call	znak_z
	call	znak_ac
	call	znak_p
	call	znak_l
	call	znak_a
	call	znak_v
	call	znak_a
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Alarm zajisten
;-------------------------------
stav01	call	dispclr
;	------------------------
	movlw	03h
	call	pozice
;	------------------------
	call	znak_a
	call	znak_l
	call	znak_a
	call	znak_r
	call	znak_m
	call	znak_
	call	znak_z
	call	znak_a
	call	znak_j
	call	znak_i
	call	znak_sh
	call	znak_t
	call	znak_eh
	call	znak_n
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Vypadek site
;-------------------------------
stav02	call	dispclr
;	------------------------
	movlw	04h
	call	pozice
;	------------------------
	call	znak_v
	call	znak_yc
	call	znak_p
	call	znak_a
	call	znak_d
	call	znak_e
	call	znak_k
	call	znak_
	call	znak_s
	call	znak_ic
	call	znak_t
	call	znak_eh
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Castecne vybaveni cidla
;-------------------------------
cidzast	call	dispclr
;	------------------------
	movlw	0x00
	call	pozice
;	------------------------
	call	znak_a
	call	znak_k
	call	znak_t
	call	znak_i
	call	znak_v
	call	znak_n
	call	znak_ic
	call	znak_
	call	znak_z
	call	znak_ac
	call	znak_p
	call	znak_l
	call	znak_te
	call	znak_
	call	znak_ch
	call	znak_i
	call	znak_d
	call	znak_l
	call	znak_o
;	------------------------
	movlw	0x43
	call	pozice
;	------------------------
	return
;-------------------------------
;	Z1a aktivni
;-------------------------------
stav03	call	cidzast
;	------------------------
	call	znak_Z
	call	znak_1
	call	znak_a
	call	znak_
	call	znak_mi
	call	znak_
	call	znak_k
	call	znak_u
	call	znak_c
	call	znak_h
	call	znak_y
	call	znak_n
	call	znak_eh
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Z1b aktivni
;-------------------------------
stav04	call	cidzast
;	------------------------
	call	znak_Z
	call	znak_1
	call	znak_b
	call	znak_
	call	znak_mi
	call	znak_
	call	znak_k
	call	znak_u
	call	znak_c
	call	znak_h
	call	znak_y
	call	znak_n
	call	znak_eh
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Z2a aktivni
;-------------------------------
stav05	call	cidzast
;	------------------------
	call	znak_Z
	call	znak_2
	call	znak_a
	call	znak_
	call	znak_mi
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_t
	call	znak_e
	call	znak_l
	call	znak_n
	call	znak_a
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Z2b aktivni
;-------------------------------
stav06	call	cidzast
;	------------------------
	call	znak_Z
	call	znak_2
	call	znak_b
	call	znak_
	call	znak_mi
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_t
	call	znak_e
	call	znak_l
	call	znak_n
	call	znak_a
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Z3a aktivni
;-------------------------------
stav07	call	cidzast
;	------------------------
	call	znak_Z
	call	znak_3
	call	znak_a
	call	znak_
	call	znak_mi
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_u
	call	znak_p
	call	znak_e
	call	znak_l
	call	znak_n
	call	znak_a
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Z3b aktivni
;-------------------------------
stav08	call	cidzast
;	------------------------
	call	znak_Z
	call	znak_3
	call	znak_b
	call	znak_
	call	znak_mi
	call	znak_
	call	znak_k
	call	znak_o
	call	znak_u
	call	znak_p
	call	znak_e
	call	znak_l
	call	znak_n
	call	znak_a
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Nizke napeti baterie (pod 12,2V)
;-------------------------------
stav09	call	dispclr
;	------------------------
	movlw	0x00
	call	pozice
;	------------------------
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_n
	call	znak_ic
	call	znak_z
	call	znak_k
	call	znak_ec
	call	znak_
	call	znak_n
	call	znak_a
	call	znak_p
	call	znak_eh
	call	znak_t
	call	znak_ic
	call	znak_
	call	znak_
	call	znak_
	call	znak_
;	------------------------
	movlw	0x40
	call	pozice
;	------------------------
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_b
	call	znak_a
	call	znak_t
	call	znak_e
	call	znak_r
	call	znak_i
	call	znak_e
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return
;-------------------------------
;	Vysoke napeti baterie (nad 14,4V)
;-------------------------------
stav10	call	dispclr
;	------------------------
	movlw	0x00
	call	pozice
;	------------------------
	call	znak_
	call	znak_
	call	znak_
	call	znak_v
	call	znak_y
	call	znak_s
	call	znak_o
	call	znak_k
	call	znak_ec
	call	znak_
	call	znak_n
	call	znak_a
	call	znak_p
	call	znak_eh
	call	znak_t
	call	znak_ic
	call	znak_
	call	znak_
	call	znak_
	call	znak_
;	------------------------
	movlw	0x40
	call	pozice
;	------------------------
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_b
	call	znak_a
	call	znak_t
	call	znak_e
	call	znak_r
	call	znak_i
	call	znak_e
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
	call	znak_
;	------------------------
	call	c2s
;	------------------------
	call	dispclr
;	------------------------
	return